## clazy 1.13

=== CMakeLists.txt ===
# This is the top-level CMakeLists.txt file for the Clazy project.
#
# To build the man page from POD, run 'make man' after CMake (assumes perl is available)
# To install the resulting man page, run 'make install'
# The man page is not available on Windows.
#

cmake_minimum_required(VERSION 3.13)

project(clazy)

include(FeatureSummary)
include(GenerateExportHeader)
include(GNUInstallDirs)

# Version setup
set(CLAZY_VERSION_MAJOR "1")
set(CLAZY_VERSION_MINOR "13")
set(CLAZY_VERSION_PATCH "0")
set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_LIST_DIR}/cmake)
if (NOT CLAZY_BUILD_WITH_CLANG)
  find_package(Clang 14.0 MODULE REQUIRED)

  if (CLANG_CLANG-CPP_LIB AND NOT APPLE)
    set(default_use_clang_cpp ON)
  else()
    set(default_use_clang_cpp OFF)
  endif()
  option(CLAZY_LINK_CLANG_DYLIB "Link clazy to dynamic Clang C++ library clang-cpp." ${default_use_clang_cpp})
endif()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

add_definitions(-D__STDC_LIMIT_MACROS -D__STDC_CONSTANT_MACROS)
add_definitions(-D_GNU_SOURCE -DHAVE_CLANG_CONFIG_H)
add_definitions(-DCLAZY_VERSION="${CLAZY_PRINT_VERSION}")

option(LINK_CLAZY_TO_LLVM "Links the clazy plugin to LLVM. Switch to OFF if your clang binary has all symbols already. Might need to be OFF if your LLVM is static." ON)
option(APPIMAGE_HACK "Links the clazy plugin to the clang tooling libs only. For some reason this is needed when building on our old CentOS 6.8 to create the AppImage." OFF)
option(CLAZY_MAN_PAGE "Builds the man page." ON)
option(CLAZY_ENABLE_SANITIZERS "Builds clazy with ASAN/UBSAN. For clazy's own development only." OFF)

if (CLAZY_ENABLE_SANITIZERS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
    if (NOT MSVC)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined")
    endif()
endif()

if(NOT CLAZY_BUILD_WITH_CLANG AND MSVC AND NOT CLANG_LIBRARY_IMPORT)
  message(FATAL_ERROR "\nOn MSVC you need to pass -DCLANG_LIBRARY_IMPORT=C:/path/to/llvm-build/lib/clang.lib to cmake when building Clazy.\nAlso make sure you've built LLVM with -DLLVM_EXPORT_SYMBOLS_FOR_PLUGINS=ON")
endif()

if(MSVC)
  # disable trigger-happy warnings from Clang/LLVM headers
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4267 /wd4244 /wd4291 /wd4800 /wd4141 /wd4146 /wd4251")
elseif(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-common -Woverloaded-virtual -Wcast-qual -fno-strict-aliasing -pedantic -Wno-long-long -Wall -W -Wno-unused-parameter -Wwrite-strings -fno-exceptions -fno-rtti")
endif()

set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
if(WIN32)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
endif()

set(CMAKE_CXX_STANDARD 17)
set(CXX_STANDARD_REQUIRED ON)

# Look for std::regex support
if(NOT DEFINED REGEX_RUN_RESULT)
  message("Looking for std::regex support...")
  try_compile(REGEX_RUN_RESULT ${CMAKE_CURRENT_BINARY_DIR} SOURCES ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_regex_test.cpp)
endif()

if(NOT DEFINED REGEX_RUN_RESULT)
  message(FATAL_ERROR "std::regex support is mandatory")
endif()

# Compiler might support c++17 but not have std::filesystem in the standard library
if (NOT FILESYSTEM_RUN_RESULT)
  try_compile(FILESYSTEM_RUN_RESULT ${CMAKE_CURRENT_BINARY_DIR} SOURCES ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_filesystem_test.cpp OUTPUT_VARIABLE foo CXX_STANDARD 17 CXX_STANDARD_REQUIRED true)
endif()

if (NOT FILESYSTEM_RUN_RESULT)
  message(FATAL_ERROR "std::filesystem support is mandatory")
endif()

include(ClazySources.cmake)

include_directories(${CMAKE_BINARY_DIR})
include_directories(${CLANG_INCLUDE_DIRS} ${CMAKE_CURRENT_LIST_DIR} ${CMAKE_CURRENT_LIST_DIR}/src)
link_directories("${LLVM_INSTALL_PREFIX}/lib" ${LLVM_LIBRARY_DIRS})

set(clang_tooling_refactoring_lib clangToolingRefactoring)

if (${LLVM_VERSION} VERSION_GREATER_EQUAL "19.0.0")
  set(clang_support_lib clangSupport)
elseif (${LLVM_VERSION} VERSION_GREATER_EQUAL "15.0.0")
  set(clang_support_lib clangSupport)
endif()

macro(link_to_llvm name is_standalone)
  if (CLAZY_LINK_CLANG_DYLIB)
    target_link_libraries(${name} clang-cpp)
  else()
    foreach(clang_lib ${CLANG_LIBS})
      if(MSVC)
        get_filename_component(LIB_FILENAME ${clang_lib} NAME)
        if(LIB_FILENAME STREQUAL "clangFrontend.lib")
          # On MSVC we don't link against clangFrontend.lib, instead we link against clang.exe (via clang.lib)
          # Otherwise the clazy plugin would have it's own plugin registry and clang wouldn't see it.
          # This way clazy registers with clang.
          continue()
        endif()
      endif()

      target_link_libraries(${name} ${clang_lib})
    endforeach()
    target_link_libraries(${name} ${clang_support_lib})
    target_link_libraries(${name} clangTooling)
    target_link_libraries(${name} clangToolingCore)
    target_link_libraries(${name} ${clang_tooling_refactoring_lib})
  endif()

  foreach(llvm_lib ${LLVM_LIBS})
    if(NOT ${is_standalone} AND NOT APPLE AND NOT MINGW AND NOT MSVC)
        ## Don't link against LLVMSupport, causes: CommandLine Error: Option 'view-background' registered more than once!
        if (NOT llvm_lib MATCHES ".*LLVMSupport.*")
            target_link_libraries(${name} ${llvm_lib})
        endif()
    else()
        target_link_libraries(${name} ${llvm_lib})
    endif()
  endforeach()

  foreach(user_lib ${USER_LIBS})
    target_link_libraries(${name} ${user_lib})
  endforeach()

  foreach(llvm_system_lib ${LLVM_SYSTEM_LIBS})
    target_link_libraries(${name} ${llvm_system_lib})
  endforeach()

  if(WIN32)
    target_link_libraries(${name} version.lib)
  endif()
endmacro()

macro(add_clang_plugin name)
  set(srcs ${ARGN})

  add_library(${name} SHARED ${srcs})

  if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.16.0")
      # 30% speedup
      target_precompile_headers(${name} PRIVATE src/checkbase.h)
  endif()

  if(SYMBOL_FILE)
    set_target_properties(${name} PROPERTIES LINK_FlAGS "-exported_symbols_list ${SYMBOL_FILE}")
  endif()

  if (LINK_CLAZY_TO_LLVM)
    link_to_llvm(${name} FALSE)
  else()
    if (APPIMAGE_HACK)
        # Hack to build on old CentOS 6.8
        target_link_libraries(${name} clangTooling)
        target_link_libraries(${name} clangToolingCore)
        target_link_libraries(${name} ${clang_tooling_refactoring_lib})
    endif()
  endif()

  if(MSVC)
    target_link_libraries(${name} ${CLANG_LIBRARY_IMPORT}) # Link against clang.exe to share the plugin registry
  endif()

endmacro()

set(SYMBOL_FILE Lazy.exports)

if (NOT CLAZY_BUILD_WITH_CLANG)
  set(CLAZY_MINI_AST_DUMPER_SRCS src/MiniAstDumper.cpp)
  add_clang_plugin(ClazyPlugin ${CLAZY_PLUGIN_SRCS} ${CLAZY_MINI_AST_DUMPER_SRCS})
  set_target_properties(ClazyPlugin PROPERTIES
    LINKER_LANGUAGE CXX
    PREFIX ""
  )

  install(TARGETS ClazyPlugin
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )

  if(NOT WIN32)
    if(APPLE)
      find_program(READLINK_CMD greadlink)
    else()
      find_program(READLINK_CMD readlink)
    endif()
    if(NOT READLINK_CMD)
      message(FATAL_ERROR "Could not find a proper readlink.  On Mac OSX you should install coreutils using homebrew in order to use the GNU readlink")
    endif()
    file(RELATIVE_PATH BIN_RELATIVE_LIBDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_LIBDIR}")
    file(RELATIVE_PATH BIN_RELATIVE_SHAREDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_DATAROOTDIR}")
    configure_file(${CMAKE_CURRENT_LIST_DIR}/clazy.cmake ${CMAKE_BINARY_DIR}/clazy @ONLY)
    install(PROGRAMS ${CMAKE_BINARY_DIR}/clazy DESTINATION bin)
  else()
    install(PROGRAMS ${CMAKE_CURRENT_LIST_DIR}/clazy.bat DESTINATION ${CMAKE_INSTALL_BINDIR})
    if(MSVC)
      install(PROGRAMS ${CMAKE_CURRENT_LIST_DIR}/clazy-cl.bat DESTINATION ${CMAKE_INSTALL_BINDIR})
    endif()
  endif()

  # Install the explanation README's
  include(${CMAKE_CURRENT_LIST_DIR}/readmes.cmake)

  install(FILES ${README_LEVEL0_FILES} DESTINATION ${CMAKE_INSTALL_DOCDIR}/level0)
  install(FILES ${README_LEVEL1_FILES} DESTINATION ${CMAKE_INSTALL_DOCDIR}/level1)
  install(FILES ${README_LEVEL2_FILES} DESTINATION ${CMAKE_INSTALL_DOCDIR}/level2)
  install(FILES ${README_manuallevel_FILES} DESTINATION ${CMAKE_INSTALL_DOCDIR}/manuallevel)

  # Install more doc files
  install(FILES README.md LICENSES/LGPL-2.0-or-later.txt checks.json DESTINATION ${CMAKE_INSTALL_DOCDIR})

  # Build docs
  if (CLAZY_MAN_PAGE)
    add_subdirectory(docs)
  endif()

  # rpath
  set(CMAKE_SKIP_BUILD_RPATH FALSE)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}" isSystemDir)
  if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
  endif("${isSystemDir}" STREQUAL "-1")

  # Build clazy-standalone
  add_executable(clazy-standalone ${CLAZY_STANDALONE_SRCS})

  if(MSVC)
    # On MSVC clang-standalone crashes with a meaningless backtrace if linked to ClazyPlugin.dll
    target_link_libraries(clazy-standalone clangFrontend)
  else()
    target_link_libraries(clazy-standalone ClazyPlugin)
  endif()

  link_to_llvm(clazy-standalone TRUE)

  install(TARGETS clazy-standalone DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)

  set(CPACK_PACKAGE_VERSION_MAJOR ${CLAZY_VERSION_MAJOR})
  set(CPACK_PACKAGE_VERSION_MINOR ${CLAZY_VERSION_MINOR})
  set(CPACK_PACKAGE_VERSION_PATCH ${CLAZY_VERSION_PATCH})
  include(CPack)
else()
  set(LLVM_LINK_COMPONENTS
    Support
    )
  add_clang_library(clazyPlugin
    ${CLAZY_PLUGIN_SRCS}

    LINK_LIBS
    clangToolingCore
    clangToolingInclusions
    ${clang_tooling_refactoring_lib}
    clangFrontend
    clangDriver
    clangCodeGen
    clangSema
    clangAnalysis
    clangRewriteFrontend
    clangRewrite
    clangAST
    clangASTMatchers
    clangParse
    clangLex
    clangBasic
    clangARCMigrate
    clangEdit
    clangFrontendTool
    clangRewrite
    clangSerialization
    ${clang_support_lib}
    clangTooling
    clangStaticAnalyzerCheckers
    clangStaticAnalyzerCore
    clangStaticAnalyzerFrontend
    )
  add_executable(clazy-standalone ${CLAZY_STANDALONE_SRCS})

  target_link_libraries(clazy-standalone clazyPlugin)

  install(TARGETS clazy-standalone DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
endif()

function(to_raw_string_literal input_string output_string)
    if (MSVC)
        # Work around "C2026: string too big, trailing characters truncated"
        #   https://docs.microsoft.com/en-us/cpp/error-messages/compiler-errors-1/compiler-error-c2026?view=vs-2019
        # The limit is 16380 single-byte characters, so split up the string as
        # suggested on the site.
        set(str ${input_string})
        set(chunk_size 1000)
        set(result "\n")
        string(LENGTH ${str} str_size)
        while (${str_size} GREATER ${chunk_size})
            string(SUBSTRING ${str} 0 ${chunk_size} chunk)
            string(SUBSTRING ${str} ${chunk_size} -1 str)
            set(chunk "R\"meta(${chunk})meta\"\n")
            string(APPEND result ${chunk})
            string(LENGTH ${str} str_size)
        endwhile()
        if (str_size GREATER 0)
            string(APPEND result "R\"meta(${str})meta\"\n")

=== debian/changelog ===
clazy (1.13-1ubuntu2) plucky; urgency=medium

  * Skip several tests failing with Qt 5; that's deprecated anyway.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sun, 09 Mar 2025 22:47:48 -0500

clazy (1.13-1ubuntu1) plucky; urgency=medium

  * Remove clang::DiagnosticsEngine::Clear() call in lieu of an upstream
    investigation (LP: #2099659).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Fri, 28 Feb 2025 21:42:22 -0600

clazy (1.13-1) unstable; urgency=medium

  * New upstream release.
  * Disable GPG key checking for now.
  * Update the patches:
    - upstream_Use-clazy-helper-to-avoid-startsWith-starts_with-dep.patch:
      drop, backported from upstream
    - upstream_Fix-clang-deprecations-by-porting-to-FileEntryRef.patch: drop,
      backported from upstream
    - upstream_Update-LLVM-Clang-support-to-14.0-add-LLVM-19-handli.patch:
      drop, backported from upstream
    - upstream_Remove-guards-for-no-longer-necessary-CLAZY_DISABLE_.patch:
      drop, backported from upstream
    - upstream_remove-the-llvm-clang-version-sepecific-macros.patch: drop,
      backported from upstream
    - upstream_Revert-overeager-cleanups-to-usageg-OptionalFileEntr.patch:
      drop, backported from upstream
    - upstream_Adjust-additional-argument-in-InclusionDirective.patch: drop,
      backported from upstream
    - upstream_Add-ifdefs-for-compatibility-with-LLVM-19.patch: drop,
      backported from upstream
    - select-clangpp.diff: refresh
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.13

 -- Pino Toscano <pino@debian.org>  Sat, 01 Feb 2025 23:11:29 +0100

clazy (1.12-3) unstable; urgency=medium

  * Backport upstream commit ccb232e435ae3d83559486fce1fdb586aaaa6e07,
    upstream commit ef4fa16bf0df98404bfb8df449dfb88e8141840e,
    upstream commit 5a86780f0db6969725bd1336b4914bc435570e88,
    upstream commit e8d2fe6ccef9276678e7bd5483ae34c4e9640035,
    upstream commit 217b1938c43fcc51ac2296cad767a4da75e1ff15,
    upstream commit cfef69f03532242688e5445b0078f2c55bb06c20,
    upstream commit dcf15ab3ece9f54e65a7cc11e8dcc5338960e866, and
    upstream commit 49ebaf30f30ede6f2ef2c2e6b57eed4a68b35104 to make clazy
    compatible with LLVM 19; patches
    upstream_Use-clazy-helper-to-avoid-startsWith-starts_with-dep.patch,
    upstream_Fix-clang-deprecations-by-porting-to-FileEntryRef.patch,
    upstream_Update-LLVM-Clang-support-to-14.0-add-LLVM-19-handli.patch,
    upstream_Remove-guards-for-no-longer-necessary-CLAZY_DISABLE_.patch,
    upstream_remove-the-llvm-clang-version-sepecific-macros.patch,
    upstream_Revert-overeager-cleanups-to-usageg-OptionalFileEntr.patch,
    upstream_Adjust-additional-argument-in-InclusionDirective.patch, and
    upstream_Add-ifdefs-for-compatibility-with-LLVM-19.patch
    (Closes: #1084393, #1000934)
    - bump clang & LLVM to 14.0
  * CI: disable the crossbuild job, as clang-N is not M-A safe.

 -- Pino Toscano <pino@debian.org>  Sun, 15 Dec 2024 19:11:44 +0100

=== debian/control ===
Source: clazy
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>
Build-Depends: chrpath,
               clang (>= 1:14.0~),
               clang-tools (>= 1:14.0~),
               cmake (>= 3.13~),
               debhelper-compat (= 13),
               libclang-cpp-dev (>= 1:14.0~),
               libclang-dev (>= 1:14.0~),
               llvm-dev (>= 1:14.0~),
               python3:any <!nocheck>,
               libqt5networkauth5-dev <!nocheck>,
               qtbase5-dev <!nocheck>,
               libqt5svg5-dev <!nocheck>,
               qtdeclarative5-dev <!nocheck>,
               qtmultimedia5-dev <!nocheck>,
               qt6-base-dev <!nocheck>,
               qt6-declarative-dev <!nocheck>,
               qt6-multimedia-dev <!nocheck>,
               qt6-networkauth-dev <!nocheck>,
               qt6-scxml-dev <!nocheck>,
               qt6-svg-dev <!nocheck>,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://www.kdab.com/clazy-video/
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/clazy

Package: clazy
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${clazy:clang}
Description: Clang plugin for additional warnings
 Clazy is a Clang plugin which extends the compiler with over
 50 warnings related to Qt best practices ranging from unneeded
 memory allocations to API misuse. It’s an opensource project
 spawned by KDAB’s R&D efforts for better C++ tooling.

Package: clazy-tests
Architecture: any
Depends: ${misc:Depends}, clazy (= ${binary:Version}),
         ${clazy:clang-tools},
Description: test files for Clazy
 This package contains all the test files needed for running the autopkgtest
 of Clazy. This is hardly useful to install in any other context than this.

=== debian/rules ===
#!/usr/bin/make -f

EMPTY :=
SPACE := $(EMPTY) $(EMPTY)
COMMA := ,

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildopts.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# LLVM 6.0 headers produce lots of class-memaccess warnings
export DEB_CXXFLAGS_MAINT_APPEND = -Wno-class-memaccess

archs_that_need_atomic = armel
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_that_need_atomic)))
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed -latomic -Wl,--as-needed
TESTS_EXTRA_LIBS += -latomic
endif

# on armel & armhf there are OpenGL ES headers
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), armel armhf))
TESTS_EXCLUDED += qt6-header-fixes
endif
TESTS_EXCLUDED += use-static-qregularexpression temporary-iterator qstring-allocations

# keep the "++" at the end, to make sure the tool used is the C++ frontend
CLANGPP=$(shell realpath $$(env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang++))++
CLANG_APPLY_REPLACEMENTS=$(shell realpath $$(which clang-apply-replacements))

DPKG_ARCHITECTURE = $(shell dpkg --print-architecture)

%:
	dh $@

execute_after_dh_auto_clean:
	# cleanup the artifacts of the tests
	find tests/ \( -name '*.o' -o -name '*.out' -o -name '*.result' -o -name '*.gch' \) -delete

override_dh_auto_configure:
	dh_auto_configure -- -DCLANGPP_EXECUTABLE="$(CLANGPP)" -DREADLINK_CMD:FILEPATH=/bin/readlink

override_dh_auto_install:
	dh_auto_install --destdir=debian/clazy
	# drop RPATH pointing to the private libdir of LLVM libraries,
	# i.e. /usr/lib/llvm-$VERSION/lib
	chrpath -d $(CURDIR)/debian/clazy/usr/bin/clazy-standalone $(CURDIR)/debian/clazy/usr/lib/*/*.so
	# drop extra license file
	rm $(CURDIR)/debian/clazy/usr/share/doc/clazy/LGPL-2.0-or-later.txt
	# create a local shell environment file with the various paths & configurations
	:> $(CURDIR)/debian/debian.sh
	echo 'export CLANG="$(CLANGPP)"' >> $(CURDIR)/debian/debian.sh
	echo 'export CLANG_APPLY_REPLACEMENTS="$(CLANG_APPLY_REPLACEMENTS)"' >> $(CURDIR)/debian/debian.sh
	echo 'export TESTS_EXCLUDED="$(TESTS_EXCLUDED)"' >> $(CURDIR)/debian/debian.sh
	echo 'export TESTS_EXTRA_LIBS="$(TESTS_EXTRA_LIBS)"' >> $(CURDIR)/debian/debian.sh
	mkdir -p $(CURDIR)/debian/clazy-tests/usr/share/clazy
	mv $(CURDIR)/debian/debian.sh $(CURDIR)/debian/clazy-tests/usr/share/clazy/debian-$(DPKG_ARCHITECTURE).sh

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	chmod +x $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/clazy
	cd tests && env PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE):$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/bin:$(PATH) LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/lib DEBIAN_EXTRA_LIBS="$(TESTS_EXTRA_LIBS)" CCACHE_DISABLE=1 ./run_tests.py --verbose --jobs $(or $(DEB_BUILD_OPTION_PARALLEL),$(DEB_BUILD_OPTION_PARALLEL),1) $(and $(TESTS_EXCLUDED),--exclude $(subst $(SPACE),$(COMMA),$(TESTS_EXCLUDED)))
endif

override_dh_compress:
	# do not compress documentation markdown & JSON files
	dh_compress -X.md -X.json

override_dh_gencontrol:
	dh_gencontrol -- \
	  -V'clazy:clang=$(shell dpkg -S "$(CLANGPP)" | cut -d: -f1)' \
	  -V'clazy:clang-tools=$(shell dpkg -S "$(CLANG_APPLY_REPLACEMENTS)" | cut -d: -f1)'

## clazy 1.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 # Version setup
 set(CLAZY_VERSION_MAJOR "1")
-set(CLAZY_VERSION_MINOR "13")
+set(CLAZY_VERSION_MINOR "14")
 set(CLAZY_VERSION_PATCH "0")
 set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
 set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")
@@ -72,16 +72,6 @@
 
 set(CMAKE_CXX_STANDARD 17)
 set(CXX_STANDARD_REQUIRED ON)
-
-# Look for std::regex support
-if(NOT DEFINED REGEX_RUN_RESULT)
-  message("Looking for std::regex support...")
-  try_compile(REGEX_RUN_RESULT ${CMAKE_CURRENT_BINARY_DIR} SOURCES ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_regex_test.cpp)
-endif()
-
-if(NOT DEFINED REGEX_RUN_RESULT)
-  message(FATAL_ERROR "std::regex support is mandatory")
-endif()
 
 # Compiler might support c++17 but not have std::filesystem in the standard library
 if (NOT FILESYSTEM_RUN_RESULT)
@@ -324,3 +314,13 @@
         endwhile()
         if (str_size GREATER 0)
             string(APPEND result "R\"meta(${str})meta\"\n")
+        endif()
+        set(${output_string} ${result} PARENT_SCOPE)
+    else()
+        set(result "\nR\"meta(${input_string})meta\"\n")
+        set(${output_string} ${result} PARENT_SCOPE)
+    endif()
+endfunction()
+
+file(READ checks.json SUPPORTED_CHECKS_JSON_STR)
+to_raw_string_literal(${SUPPORTED_CHECKS_JSON_STR} SUPPORTED_CHECKS_JSON_STR)

=== debian/changelog ===
clazy (1.14-1) unstable; urgency=medium

  * New upstream release:
    - supports building with LLVM 20
  * Bump Standards-Version to 4.7.2, no changes required.

 -- Pino Toscano <pino@debian.org>  Tue, 29 Apr 2025 08:37:54 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: clazy
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>
 Build-Depends: chrpath,
                clang (>= 1:14.0~),
@@ -24,7 +23,7 @@
                qt6-networkauth-dev <!nocheck>,
                qt6-scxml-dev <!nocheck>,
                qt6-svg-dev <!nocheck>,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://www.kdab.com/clazy-video/
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,6 @@
 ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), armel armhf))
 TESTS_EXCLUDED += qt6-header-fixes
 endif
-TESTS_EXCLUDED += use-static-qregularexpression temporary-iterator qstring-allocations
 
 # keep the "++" at the end, to make sure the tool used is the C++ frontend
 CLANGPP=$(shell realpath $$(env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang++))++

## clazy 1.15

=== debian/changelog ===
clazy (1.15-2ubuntu1) questing; urgency=medium

  * Skip old-style-connect test failing with Qt5

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 05 Sep 2025 13:54:12 +0000

clazy (1.15-2) unstable; urgency=medium

  * Upload to unstable.
  * Switch Vcs-* fields back to the 'master' packaging branch.

 -- Pino Toscano <pino@debian.org>  Sun, 10 Aug 2025 09:58:46 +0200

clazy (1.15-1) experimental; urgency=medium

  * New upstream release.
  * Switch Vcs-* fields to the 'experimental' packaging branch.
  * Update the build dependencies according to the upstream build system:
    - bump clang & LLVM to 19.0
  * Drop -Wno-class-memaccess from the CXXFLAGS, as the problem should be fixed
    with very recent LLVM versions (which are a requirement now).
  * Update the patches:
    - select-clangpp.diff: refresh

 -- Pino Toscano <pino@debian.org>  Thu, 19 Jun 2025 07:39:10 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: clazy
 Section: devel
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>
 Build-Depends: chrpath,
-               clang (>= 1:14.0~),
-               clang-tools (>= 1:14.0~),
+               clang (>= 1:19.0~),
+               clang-tools (>= 1:19.0~),
                cmake (>= 3.13~),
                debhelper-compat (= 13),
-               libclang-cpp-dev (>= 1:14.0~),
-               libclang-dev (>= 1:14.0~),
-               llvm-dev (>= 1:14.0~),
+               libclang-cpp-dev (>= 1:19.0~),
+               libclang-dev (>= 1:19.0~),
+               llvm-dev (>= 1:19.0~),
                python3:any <!nocheck>,
                libqt5networkauth5-dev <!nocheck>,
                qtbase5-dev <!nocheck>,

=== debian/rules ===
--- 
+++ 
@@ -9,9 +9,6 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
-# LLVM 6.0 headers produce lots of class-memaccess warnings
-export DEB_CXXFLAGS_MAINT_APPEND = -Wno-class-memaccess
-
 archs_that_need_atomic = armel
 ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_that_need_atomic)))
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed -latomic -Wl,--as-needed
@@ -22,6 +19,8 @@
 ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), armel armhf))
 TESTS_EXCLUDED += qt6-header-fixes
 endif
+# skip tests failing with Qt5
+TESTS_EXCLUDED += old-style-connect
 
 # keep the "++" at the end, to make sure the tool used is the C++ frontend
 CLANGPP=$(shell realpath $$(env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang++))++

=== debian/tests/control ===
Tests: run-tests
Depends: @, clazy-tests, python3, qtbase5-dev, libqt5networkauth5-dev, libqt5svg5-dev, qtdeclarative5-dev, qtmultimedia5-dev, qt6-base-dev, qt6-declarative-dev, qt6-multimedia-dev, qt6-networkauth-dev, qt6-scxml-dev, qt6-svg-dev
Restrictions: rw-build-tree, allow-stderr

=== debian/watch ===
version=4
https://download.kde.org/stable/@PACKAGE@/([\d\.]*)/src/@PACKAGE@-([^-]*).tar.xz

## clazy 1.15+p24.04+vstable+git20250907.2235

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,12 +15,17 @@
 
 # Version setup
 set(CLAZY_VERSION_MAJOR "1")
-set(CLAZY_VERSION_MINOR "14")
+set(CLAZY_VERSION_MINOR "17")
 set(CLAZY_VERSION_PATCH "0")
 set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
 set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_LIST_DIR}/cmake)
+
+if(EXISTS "${CMAKE_SOURCE_DIR}/.git" AND IS_DIRECTORY "${CMAKE_SOURCE_DIR}/.git")
+    include(gitversion)
+endif()
+
 if (NOT CLAZY_BUILD_WITH_CLANG)
   find_package(Clang 14.0 MODULE REQUIRED)
 
@@ -44,6 +49,12 @@
 option(APPIMAGE_HACK "Links the clazy plugin to the clang tooling libs only. For some reason this is needed when building on our old CentOS 6.8 to create the AppImage." OFF)
 option(CLAZY_MAN_PAGE "Builds the man page." ON)
 option(CLAZY_ENABLE_SANITIZERS "Builds clazy with ASAN/UBSAN. For clazy's own development only." OFF)
+option(CLAZY_BUILD_CLANG_TIDY "Builds clang-tidy plugin" ON)
+
+# not available on opensuse CI, only BSD for now
+if ($ENV{CI_JOB_NAME_SLUG} MATCHES "suse-tumbleweed")
+  set(CLAZY_BUILD_CLANG_TIDY OFF)
+endif()
 
 if (CLAZY_ENABLE_SANITIZERS)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
@@ -70,17 +81,8 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
 endif()
 
-set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD 20)
 set(CXX_STANDARD_REQUIRED ON)
-
-# Compiler might support c++17 but not have std::filesystem in the standard library
-if (NOT FILESYSTEM_RUN_RESULT)
-  try_compile(FILESYSTEM_RUN_RESULT ${CMAKE_CURRENT_BINARY_DIR} SOURCES ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_filesystem_test.cpp OUTPUT_VARIABLE foo CXX_STANDARD 17 CXX_STANDARD_REQUIRED true)
-endif()
-
-if (NOT FILESYSTEM_RUN_RESULT)
-  message(FATAL_ERROR "std::filesystem support is mandatory")
-endif()
 
 include(ClazySources.cmake)
 
@@ -89,12 +91,7 @@
 link_directories("${LLVM_INSTALL_PREFIX}/lib" ${LLVM_LIBRARY_DIRS})
 
 set(clang_tooling_refactoring_lib clangToolingRefactoring)
-
-if (${LLVM_VERSION} VERSION_GREATER_EQUAL "19.0.0")
-  set(clang_support_lib clangSupport)
-elseif (${LLVM_VERSION} VERSION_GREATER_EQUAL "15.0.0")
-  set(clang_support_lib clangSupport)
-endif()
+set(clang_support_lib clangSupport)
 
 macro(link_to_llvm name is_standalone)
   if (CLAZY_LINK_CLANG_DYLIB)
@@ -295,6 +292,28 @@
   install(TARGETS clazy-standalone DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
 endif()
 
+
+if (CLAZY_BUILD_CLANG_TIDY)
+  find_path(CLANG_TIDY_MODULE_REGISTRY_HEADER
+      NAMES clang-tidy/ClangTidyModule.h
+      PATHS ${CLANG_INCLUDE_DIRS}
+  )
+  if (NOT CLANG_TIDY_MODULE_REGISTRY_HEADER)
+    message(FATAL_ERROR "Could not find ClangTidyModule.h header")
+  endif()
+  add_clang_plugin(ClazyClangTidy src/ClazyClangTidyModule.cpp)
+  target_link_libraries(ClazyClangTidy ClazyPlugin)
+  set_target_properties(ClazyClangTidy PROPERTIES
+    LINKER_LANGUAGE CXX
+    PREFIX ""
+  )
+  install(TARGETS ClazyClangTidy
+    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+  )
+endif()
+
 function(to_raw_string_literal input_string output_string)
     if (MSVC)
         # Work around "C2026: string too big, trailing characters truncated"
@@ -312,15 +331,3 @@
             string(APPEND result ${chunk})
             string(LENGTH ${str} str_size)
         endwhile()
-        if (str_size GREATER 0)
-            string(APPEND result "R\"meta(${str})meta\"\n")
-        endif()
-        set(${output_string} ${result} PARENT_SCOPE)
-    else()
-        set(result "\nR\"meta(${input_string})meta\"\n")
-        set(${output_string} ${result} PARENT_SCOPE)
-    endif()
-endfunction()
-
-file(READ checks.json SUPPORTED_CHECKS_JSON_STR)
-to_raw_string_literal(${SUPPORTED_CHECKS_JSON_STR} SUPPORTED_CHECKS_JSON_STR)

=== debian/changelog ===
clazy (1.15+p24.04+vstable+git20250907.2235-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 07 Sep 2025 22:35:46 +0000

clazy (1.15-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 14 Jun 2025 20:30:56 +0000

clazy (1.14-1) noble; urgency=medium

  * New upstream release:
    - supports building with LLVM 20
  * Bump Standards-Version to 4.7.2, no changes required.

 -- Pino Toscano <pino@debian.org>  Tue, 29 Apr 2025 08:37:54 +0200

clazy (1.14-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 28 Apr 2025 19:12:10 +0000

clazy (1.13-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sun, 29 Dec 2024 19:12:10 +0000

clazy (1.12-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 02 Jul 2024 19:12:08 +0000

## clazy 1.15+p24.04+vstable+git20250917.0417

=== CMakeLists.txt ===
--- 
+++ 
@@ -188,13 +188,14 @@
   )
 
   if(NOT WIN32)
+     find_program(READLINK_CMD readlink)
+
     if(APPLE)
-      find_program(READLINK_CMD greadlink)
-    else()
-      find_program(READLINK_CMD readlink)
-    endif()
-    if(NOT READLINK_CMD)
-      message(FATAL_ERROR "Could not find a proper readlink.  On Mac OSX you should install coreutils using homebrew in order to use the GNU readlink")
+      # for historic reasons we prefer greadlink
+      find_program(GREADLINK_CMD greadlink)
+      if (GREADLINK_CMD)
+        set(READLINK_CMD ${GREADLINK_CMD})
+      endif()
     endif()
     file(RELATIVE_PATH BIN_RELATIVE_LIBDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_LIBDIR}")
     file(RELATIVE_PATH BIN_RELATIVE_SHAREDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_DATAROOTDIR}")
@@ -331,3 +332,4 @@
             string(APPEND result ${chunk})
             string(LENGTH ${str} str_size)
         endwhile()
+        if (str_size GREATER 0)

=== debian/changelog ===
clazy (1.15+p24.04+vstable+git20250917.0417-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 17 Sep 2025 04:17:40 +0000

## clazy 1.15+p24.04+vstable+git20251012.0154

=== debian/changelog ===
clazy (1.15+p24.04+vstable+git20251012.0154-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 12 Oct 2025 01:54:26 +0000

## clazy 1.15+p24.04+vstable+git20251015.0749

=== debian/changelog ===
clazy (1.15+p24.04+vstable+git20251015.0749-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 15 Oct 2025 07:49:17 +0000

## clazy 1.15+p24.04+vstable+git20260102.1123

=== debian/changelog ===
clazy (1.15+p24.04+vstable+git20260102.1123-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 02 Jan 2026 11:23:13 +0000

=== debian/control ===
Source: clazy
Section: devel
Priority: optional
Uploaders: Scarlett Clark <sgclark@kde.org>, Pino Toscano <pino@debian.org>
Build-Depends: chrpath,
               clang-19,
               clang-tools-19,
               cmake,
               debhelper-compat (= 13),
               libclang-19-dev,
               libclang-cpp19-dev,
               libqt5networkauth5-dev <!nocheck>,
               libqt5svg5-dev <!nocheck>,
               llvm-19-dev,
               python3:any <!nocheck>,
               qt6-base-dev <!nocheck>,
               qt6-declarative-dev <!nocheck>,
               qt6-multimedia-dev <!nocheck>,
               qt6-networkauth-dev <!nocheck>,
               qt6-scxml-dev <!nocheck>,
               qt6-svg-dev <!nocheck>,
               qtbase5-dev <!nocheck>,
               qtdeclarative5-dev <!nocheck>,
               qtmultimedia5-dev <!nocheck>
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://www.kdab.com/clazy-video/
Vcs-Git: https://invent.kde.org/neon/extras/clazy.git
Vcs-Browser: https://invent.kde.org/neon/extras/clazy
Maintainer: Neon CI <neon@kde.org>

Package: clazy
Architecture: any
Depends: ${clazy:clang}, ${misc:Depends}, ${shlibs:Depends}
Description: Clang plugin for additional warnings
 Clazy is a Clang plugin which extends the compiler with over
 50 warnings related to Qt best practices ranging from unneeded
 memory allocations to API misuse. It’s an opensource project
 spawned by KDAB’s R&D efforts for better C++ tooling.

Package: clazy-tests
Architecture: any
Depends: clazy (= ${binary:Version}), ${clazy:clang-tools}, ${misc:Depends}
Description: test files for Clazy
 This package contains all the test files needed for running the autopkgtest
 of Clazy. This is hardly useful to install in any other context than this.

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,9 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
+# LLVM 6.0 headers produce lots of class-memaccess warnings
+export DEB_CXXFLAGS_MAINT_APPEND = -Wno-class-memaccess
+
 archs_that_need_atomic = armel
 ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_that_need_atomic)))
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed -latomic -Wl,--as-needed
@@ -19,11 +22,9 @@
 ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), armel armhf))
 TESTS_EXCLUDED += qt6-header-fixes
 endif
-# skip tests failing with Qt5
-TESTS_EXCLUDED += old-style-connect
 
 # keep the "++" at the end, to make sure the tool used is the C++ frontend
-CLANGPP=$(shell realpath $$(env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang++))++
+CLANGPP=$(shell realpath $$(env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang++-19))++
 CLANG_APPLY_REPLACEMENTS=$(shell realpath $$(which clang-apply-replacements))
 
 DPKG_ARCHITECTURE = $(shell dpkg --print-architecture)

## clazy 1.15+p24.04+vstable+git20260107.0657

=== debian/changelog ===
clazy (1.15+p24.04+vstable+git20260107.0657-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 07 Jan 2026 06:57:21 +0000

## clazy 1.15+p24.04+vstable+git20260126.0725

=== debian/changelog ===
clazy (1.15+p24.04+vstable+git20260126.0725-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 26 Jan 2026 07:25:35 +0000

## clazy 1.15+p24.04+vunstable+git20251111.0337

=== debian/changelog ===
clazy (1.15+p24.04+vunstable+git20251111.0337-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 11 Nov 2025 03:37:04 +0000

## clazy 1.15+p24.04+vunstable+git20251125.0153

=== debian/changelog ===
clazy (1.15+p24.04+vunstable+git20251125.0153-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 25 Nov 2025 01:53:30 +0000

## clazy 1.15+p24.04+vunstable+git20260109.1032

=== debian/changelog ===
clazy (1.15+p24.04+vunstable+git20260109.1032-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 09 Jan 2026 10:32:35 +0000

## clazy 1.15+p24.04+vunstable+git20260129.0256

=== debian/changelog ===
clazy (1.15+p24.04+vunstable+git20260129.0256-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 29 Jan 2026 02:56:35 +0000

## clazy 1.16

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 # Version setup
 set(CLAZY_VERSION_MAJOR "1")
-set(CLAZY_VERSION_MINOR "17")
+set(CLAZY_VERSION_MINOR "16")
 set(CLAZY_VERSION_PATCH "0")
 set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
 set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")
@@ -81,8 +81,17 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
 endif()
 
-set(CMAKE_CXX_STANDARD 20)
+set(CMAKE_CXX_STANDARD 17)
 set(CXX_STANDARD_REQUIRED ON)
+
+# Compiler might support c++17 but not have std::filesystem in the standard library
+if (NOT FILESYSTEM_RUN_RESULT)
+  try_compile(FILESYSTEM_RUN_RESULT ${CMAKE_CURRENT_BINARY_DIR} SOURCES ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_filesystem_test.cpp OUTPUT_VARIABLE foo CXX_STANDARD 17 CXX_STANDARD_REQUIRED true)
+endif()
+
+if (NOT FILESYSTEM_RUN_RESULT)
+  message(FATAL_ERROR "std::filesystem support is mandatory")
+endif()
 
 include(ClazySources.cmake)
 
@@ -188,14 +197,13 @@
   )
 
   if(NOT WIN32)
-     find_program(READLINK_CMD readlink)
-
     if(APPLE)
-      # for historic reasons we prefer greadlink
-      find_program(GREADLINK_CMD greadlink)
-      if (GREADLINK_CMD)
-        set(READLINK_CMD ${GREADLINK_CMD})
-      endif()
+      find_program(READLINK_CMD greadlink)
+    else()
+      find_program(READLINK_CMD readlink)
+    endif()
+    if(NOT READLINK_CMD)
+      message(FATAL_ERROR "Could not find a proper readlink.  On Mac OSX you should install coreutils using homebrew in order to use the GNU readlink")
     endif()
     file(RELATIVE_PATH BIN_RELATIVE_LIBDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_LIBDIR}")
     file(RELATIVE_PATH BIN_RELATIVE_SHAREDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_DATAROOTDIR}")
@@ -322,14 +330,3 @@
         # The limit is 16380 single-byte characters, so split up the string as
         # suggested on the site.
         set(str ${input_string})
-        set(chunk_size 1000)
-        set(result "\n")
-        string(LENGTH ${str} str_size)
-        while (${str_size} GREATER ${chunk_size})
-            string(SUBSTRING ${str} 0 ${chunk_size} chunk)
-            string(SUBSTRING ${str} ${chunk_size} -1 str)
-            set(chunk "R\"meta(${chunk})meta\"\n")
-            string(APPEND result ${chunk})
-            string(LENGTH ${str} str_size)
-        endwhile()
-        if (str_size GREATER 0)

=== docs/man/CMakeLists.txt ===
if(UNIX)
  find_program(POD2MAN_EXECUTABLE pod2man)
  set_package_properties(pod2man PROPERTIES
    TYPE RECOMMENDED
    DESCRIPTION "Man page generator"
    PURPOSE "Generate clazy man pages."
  )

  if(POD2MAN_EXECUTABLE)
    add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/clazy.1
      COMMAND ${POD2MAN_EXECUTABLE} -c "KDAB" -r "\"${CLAZY_VERSION}\"" -s 1 ${CMAKE_CURRENT_SOURCE_DIR}/clazy.pod ${CMAKE_CURRENT_BINARY_DIR}/clazy.1
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/clazy.pod
    )
    add_custom_target(man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/clazy.1)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/clazy.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
  endif()
endif()

=== debian/changelog ===
clazy (1.16-1) unstable; urgency=medium

  * New upstream release. (Closes: #1116118)
  * Update watch file to work with newer versions of uscan.
  * Update the patches:
    - debian-tests-extra-libs.diff: refresh
    - select-clangpp.diff: refresh
  * The new version builds & tests a plugin for clang-tidy, so:
    - add clang-tidy as build dependency
    - save the path of the actual (versioned) clang-tidy executable, in the same
      way as done for clang-apply-replacements
    - make the clazy-tests package install the needed clang-tidy package
    - tweak the upstream testsuite to use the clang-tidy executable as specified
      using an environment variable; patch tests-clang-tidy-envvar.diff
  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Tue, 30 Sep 2025 18:31:13 +0200

=== debian/control ===
Source: clazy
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>
Build-Depends: chrpath,
               clang (>= 1:19.0~),
               clang-tidy (>= 1:19.0~),
               clang-tools (>= 1:19.0~),
               cmake (>= 3.13~),
               debhelper-compat (= 13),
               libclang-cpp-dev (>= 1:19.0~),
               libclang-dev (>= 1:19.0~),
               llvm-dev (>= 1:19.0~),
               python3:any <!nocheck>,
               libqt5networkauth5-dev <!nocheck>,
               qtbase5-dev <!nocheck>,
               libqt5svg5-dev <!nocheck>,
               qtdeclarative5-dev <!nocheck>,
               qtmultimedia5-dev <!nocheck>,
               qt6-base-dev <!nocheck>,
               qt6-declarative-dev <!nocheck>,
               qt6-multimedia-dev <!nocheck>,
               qt6-networkauth-dev <!nocheck>,
               qt6-scxml-dev <!nocheck>,
               qt6-svg-dev <!nocheck>,
Standards-Version: 4.7.2
Homepage: https://www.kdab.com/clazy-video/
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/clazy

Package: clazy
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${clazy:clang}
Description: Clang plugin for additional warnings
 Clazy is a Clang plugin which extends the compiler with over
 50 warnings related to Qt best practices ranging from unneeded
 memory allocations to API misuse. It’s an opensource project
 spawned by KDAB’s R&D efforts for better C++ tooling.

Package: clazy-tests
Architecture: any
Depends: ${misc:Depends}, clazy (= ${binary:Version}),
         ${clazy:clang-tidy},
         ${clazy:clang-tools},
Description: test files for Clazy
 This package contains all the test files needed for running the autopkgtest
 of Clazy. This is hardly useful to install in any other context than this.

=== debian/rules ===
--- 
+++ 
@@ -8,9 +8,6 @@
 include /usr/share/dpkg/buildopts.mk
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-
-# LLVM 6.0 headers produce lots of class-memaccess warnings
-export DEB_CXXFLAGS_MAINT_APPEND = -Wno-class-memaccess
 
 archs_that_need_atomic = armel
 ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_that_need_atomic)))
@@ -24,8 +21,9 @@
 endif
 
 # keep the "++" at the end, to make sure the tool used is the C++ frontend
-CLANGPP=$(shell realpath $$(env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang++-19))++
+CLANGPP=$(shell realpath $$(env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang++))++
 CLANG_APPLY_REPLACEMENTS=$(shell realpath $$(which clang-apply-replacements))
+CLANG_TIDY=$(shell realpath $$(which clang-tidy))
 
 DPKG_ARCHITECTURE = $(shell dpkg --print-architecture)
 
@@ -50,6 +48,7 @@
 	:> $(CURDIR)/debian/debian.sh
 	echo 'export CLANG="$(CLANGPP)"' >> $(CURDIR)/debian/debian.sh
 	echo 'export CLANG_APPLY_REPLACEMENTS="$(CLANG_APPLY_REPLACEMENTS)"' >> $(CURDIR)/debian/debian.sh
+	echo 'export CLANG_TIDY="$(CLANG_TIDY)"' >> $(CURDIR)/debian/debian.sh
 	echo 'export TESTS_EXCLUDED="$(TESTS_EXCLUDED)"' >> $(CURDIR)/debian/debian.sh
 	echo 'export TESTS_EXTRA_LIBS="$(TESTS_EXTRA_LIBS)"' >> $(CURDIR)/debian/debian.sh
 	mkdir -p $(CURDIR)/debian/clazy-tests/usr/share/clazy
@@ -68,4 +67,5 @@
 override_dh_gencontrol:
 	dh_gencontrol -- \
 	  -V'clazy:clang=$(shell dpkg -S "$(CLANGPP)" | cut -d: -f1)' \
+	  -V'clazy:clang-tidy=$(shell dpkg -S "$(CLANG_TIDY)" | cut -d: -f1)' \
 	  -V'clazy:clang-tools=$(shell dpkg -S "$(CLANG_APPLY_REPLACEMENTS)" | cut -d: -f1)'

=== debian/watch ===
version=4
https://download.kde.org/stable/clazy/([\d\.]*)/src/@PACKAGE@-v?([^-]*).tar.xz
